



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Docker仓库(四)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Docker仓库(四)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 15:08:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、什么是仓库</h2>
<p>　　仓库就是集中存放镜像的地方，分为公共仓库和私有仓库，一个容易混淆的概念是注册服务器，实际上注册服务器是存放仓库的具体服务器，一个注册服务器可以有多个仓库，而每个仓库下面有多个镜像</p>
<h2>二、使用Docker官方公共仓库</h2>
<p>　　官方仓库地址:<a href="https://hub.docker.com/" rel="external nofollow noreferrer">DockerHub</a></p>
<h4>2.1. 登录仓库</h4>
<p>　　使用docker login 命令来登录官方的公共仓库</p>
<div>
<pre class="prettyprint linenums">[root@rsync131 ~]# docker login<br />
Login with your Docker ID to push and pull images from Docker Hub. If you don't have a Docker ID, head over to https://hub.docker.com to create one.<br />
Username: brianzjz<br />
Password:<br />
Login Succeeded

没有用户名密码的可以去官方注册一个</pre>
</div>
<h4>2.2. 下载镜像</h4>
<p>　　使用docker pull 命令下载镜像</p>
<div>
<pre class="prettyprint linenums">[root@rsync131 ~]# docker pull nginx<br />
Using default tag: latest<br />
Trying to pull repository docker.io/library/nginx ...<br />
latest: Pulling from docker.io/library/nginx<br />
802b00ed6f79: Pull complete<br />
e9d0e0ea682b: Pull complete<br />
d8b7092b9221: Pull complete<br />
Digest: sha256:24a0c4b4a4c0eb97a1aabb8e29f18e917d05abfe1b7a7c07857230879ce7d3d3<br />
Status: Downloaded newer image for docker.io/nginx:latest</pre>
</div>
<h4>2.3. 推送镜像</h4>
<p>　　使用docker push 命令推送镜像</p>
<div>
<pre class="prettyprint linenums">[root@rsync131 ~]# docker push brianzjz/nginx:v1.0<br />
The push refers to a repository [docker.io/brianzjz/nginx]<br />
579c75bb43c0: Mounted from library/nginx<br />
67d3ae5dfa34: Mounted from library/nginx<br />
8b15606a9e3e: Mounted from library/nginx<br />
v1.0: digest: sha256:c0b69559d28fb325a64c6c8f47d14c26b95aa047312b29c699da10380e90b4d7 size: 948</pre>
</div>
<h2>三、国内第三方公共仓库</h2>
<p>　　使用国内的仓库就是为了能提高下载的速度：想要达到火箭的速度 请点击：<a href="https://www.cnblogs.com/brianzhu/p/8565411.html" rel="external nofollow noreferrer">火箭加速器</a></p>
<h2>四、搭建自己的本地仓库</h2>
<p>　　这个私有仓库才是重点，在我们的企业中很多都会是自己去定制自己的镜像文件，有一些还必须不能对外开放的，也是能够为了提高在内网的下载速度，这样我们就要搭建自己的私有仓库了</p>
<h4>4.1. 使用registry镜像创建私有仓库</h4>
<p>　　安装docker后，可以通过官方提供的registry镜像来简单的搭建一套本地的私有仓库</p>
<div>
<pre class="prettyprint linenums">[root@rsync131 ~]# mkdir -p /opt/data/docker/                                                  # 创建存放镜像的目录<br />
[root@rsync131 ~]# docker run -it -d -p 5000:5000 -v /opt/data/docker:/tmp/registry registry   # 创建容器 -p指定端口 -v数据卷挂载<br />
Unable to find image 'registry:latest' locally<br />
Trying to pull repository docker.io/library/registry ...<br />
latest: Pulling from docker.io/library/registry<br />
d6a5679aa3cf: Pull complete<br />
ad0eac849f8f: Pull complete<br />
2261ba058a15: Pull complete<br />
f296fda86f10: Pull complete<br />
bcd4a541795b: Pull complete<br />
Digest: sha256:5a156ff125e5a12ac7fdec2b90b7e2ae5120fa249cf62248337b6d04abc574c8<br />
Status: Downloaded newer image for docker.io/registry:latest<br />
6df20cdacf8d4a40ad3cbd3d310299650d41d0757b535130a0daa19f21ee1901<br />
[root@rsync131 ~]# docker ps<br />
CONTAINER ID        IMAGE               COMMAND                  CREATED             STATUS              PORTS                    NAMES<br />
6df20cdacf8d        registry            "/entrypoint.sh /e..."   8 seconds ago       Up 7 seconds        0.0.0.0:5000-&gt;5000/tcp   dazzling_golick
</pre>
</div>
<h4>4.2. 管理私有仓库</h4>
<p>　　用另一台机器来测试上传下载私有仓库</p>
<div>
<pre class="prettyprint linenums">[root@nfs133 ~]# docker images<br />
REPOSITORY          TAG                 IMAGE ID            CREATED             SIZE<br />
[root@nfs133 ~]# docker pull nginx<br />
Using default tag: latest<br />
Trying to pull repository docker.io/library/nginx ...<br />
latest: Pulling from docker.io/library/nginx<br />
802b00ed6f79: Pull complete<br />
e9d0e0ea682b: Pull complete<br />
d8b7092b9221: Pull complete<br />
Digest: sha256:24a0c4b4a4c0eb97a1aabb8e29f18e917d05abfe1b7a7c07857230879ce7d3d3<br />
Status: Downloaded newer image for docker.io/nginx:latest<br />
[root@nfs133 ~]# docker tag nginx 192.168.73.131:5000/nginx_test<br />
[root@nfs133 ~]# docker images<br />
REPOSITORY                       TAG                 IMAGE ID            CREATED             SIZE<br />
192.168.73.131:5000/nginx_test   latest              06144b287844        2 weeks ago         109 MB<br />
docker.io/nginx                  latest              06144b287844        2 weeks ago         109 MB<br />
=================================================<br />
[root@nfs133 ~]# docker push 192.168.73.131:5000/nginx_test<br />
The push refers to a repository [192.168.73.131:5000/nginx_test]<br />
Get https://192.168.73.131:5000/v1/_ping: http: server gave HTTP response to HTTPS client

这里执行的时候报错了，原因就是新版本的docker对安全性要求高了，会要求仓库支持SSL/TLS证书

解决方法：<br />
修改daemon配置文件<br />
[root@nfs133 ~]# vim /etc/sysconfig/docker<br />
OPTIONS='--selinux-enabled --log-driver=journald --signature-verification=false  # 原来的配置<br />
修改为：<br />
OPTIONS='--selinux-enabled --log-driver=journald --signature-verification=false --insecure-registry 192.168.73.131:5000'<br />
保存后，重启docker<br />
[root@nfs133 ~]# systemctl restart docker

=================================================<br />
# 重新执行push<br />
[root@nfs133 ~]# docker push 192.168.73.131:5000/nginx_test<br />
The push refers to a repository [192.168.73.131:5000/nginx_test]<br />
579c75bb43c0: Pushed<br />
67d3ae5dfa34: Pushed<br />
8b15606a9e3e: Pushed<br />
latest: digest: sha256:c0b69559d28fb325a64c6c8f47d14c26b95aa047312b29c699da10380e90b4d7 size: 948

# curl 测试<br />
# 温馨提示：下面的执行是错的 因为registry现在已经是2.0版本了<br />
[root@nfs133 ~]# curl http://192.168.73.131:5000/v1/search<br />
404 page not found

# 正确的方式<br />
[root@nfs133 ~]# curl -X GET http://192.168.73.131:5000/v2/_catalog<br />
{"repositories":["nginx_test"]}

# 下载私有仓库镜像<br />
[root@nfs133 ~]# docker pull 192.168.73.131:5000/nginx_test<br />
Using default tag: latest<br />
Trying to pull repository 192.168.73.131:5000/nginx_test ...<br />
latest: Pulling from 192.168.73.131:5000/nginx_test<br />
Digest: sha256:c0b69559d28fb325a64c6c8f47d14c26b95aa047312b29c699da10380e90b4d7<br />
Status: Downloaded newer image for 192.168.73.131:5000/nginx_test:latest<br />
[root@nfs133 ~]# docker images<br />
REPOSITORY                       TAG                 IMAGE ID            CREATED             SIZE<br />
192.168.73.131:5000/nginx_test   latest              06144b287844        2 weeks ago         109 MB<br />
docker.io/nginx                  latest              06144b287844        2 weeks ago         109 MB
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m4408k.html">Java集合专题总结（1）：HashMap 和 HashTable 源码学习和面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o10plq.html">Android AlertDialog去除黑边白边自定义布局&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2jor8.html">同一服务器上多个版本的 sqlserver　，如何连接，改变某一实例的端口号</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkdpe9.html">&lbrack;转载&rsqb; linux 速查表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mv7eq.html">Enum枚举类型的使用笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdmzxr8.html">&lbrack;转载&rsqb;MongoDB的真正性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xl0k8.html">Robotium -- AndroidUI优化工具HierarchyViewer</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x5xyw9.html">hdu 4619 Warm up 2&lowbar;最大独立集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z15wdv9.html">Codeforces 116C - Party（dfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zlrje9.html">android：在ViewPager中使用Button</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxr2y9.html">CentOS下安装node</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kdwmq.html">jsp内置对象-config对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4kd2k9.html">JS 8-4 OOP instanceof</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvz7lj8.html">SpringBoot 读取properties配置文件 &commat;Value使用 中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2x7ny9.html">【笔记】CSS选择器整理（IE低版本支持性测试）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpjmwl9.html">规避javascript多人开发函数重名问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjww1jq.html">java 转义符</a>
		</li>
						<li><a href="https://www.batexi.com/a/953gme68.html">git for c&num;&comma;文件改动内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kom265q.html">【linux系列】yum安装报错 no mirrors to try</a>
		</li>
						<li><a href="https://www.batexi.com/a/902nv1jq.html">（转）U3D DrawCall优化手记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25r04xq.html">2018&period;11&period;06 洛谷P1941 飞扬的小鸟（背包）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25r2d3q.html">纯css实现蒙层loading效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/90roppm9.html">关于oracle的基础增删改查操作总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwz30z8.html">SQL2008 2机镜像</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwmglv9.html">简单的dialog，类似alert弹框</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25rg1wq.html">git 版本库拆分和subtree用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwmxxx9.html">linux搭建简易版本的FastDFS服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllyxy1q.html">20171123IdleHandler</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjl0kl9.html">CGLIB介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2xpro9.html">DataStage 的优化原则</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
